#!/usr/bin/python
#License: GPL Version 2.0
#author: Dave Aitel
#http://www.immunitysec.com/ for more information
# import MySQL module
import MySQLdb
import time
import getopt
import os
import sys
import md5


dbuser="nobody"
dbpassword="password"
dbname="hashdb"

db = MySQLdb.connect(host="localhost", user=dbuser, passwd=dbpassword, db=dbname)

#md5 sums a file
def getmd5sum(filename):
    m=md5.new()
    f=open(filename)
    #insert error checking here
    s=f.read()
    f.close()
    m.update(s)
    return m.hexdigest()


def getallhashes(filename):

    cursor = db.cursor()
    query="SELECT * FROM hashes WHERE filename='"+filename+"';"
    cursor.execute(query)
    result=cursor.fetchall()
    print result
    return

def insertentry(filename,hash,moderator,description="",keywords=""):

    date=time.strftime("%Y-%m-%d")
    cursor = db.cursor()
    query="INSERT INTO hashes (filename, hash, moderator, description, keywords, date_entered) VALUES ('"+filename+"','"+hash+"','"+moderator+"','"+description+"','"+keywords+"','"+date+"' );"
    cursor.execute(query)
    return

def deletehash(hash):
    cursor=db.cursor()
    query="DROP * FROM hashes WHERE hash='"+hash+"';"
    cursor.execute(query)
    return


def deletefile(filename):
    cursor=db.cursor()
    query="DELETE FROM hashes WHERE filename='"+filename+"';"
    cursor.execute(query)
    return

#prints usage menu and then exits
def usage():
    print """
    usage: ./loadhash.py [options]
    options include:
    -f n    where n is the filename
    -l      load the hash of a specified filename
    -m n    where n is the moderator to load
    -d n    where n is the description of the hash (trojan, clean, vulnerable)
    -k n    where n is keywords that apply (name of trojan, etc)
    -s      search for hashes of filename
    -t n    where n is a hash to store or look for
    -D      delete all keys that match a certain filename or hash
    """
    sys.exit(1)


if __name__=='__main__':

    search=0
    filename=""
    load=0
    help=0
    description="clean"
    moderator=""
    keywords=""
    hash=""
    delete=0
    
    try:
        (opts,args)=getopt.getopt(sys.argv[1:],"f:lm:d:k:st:hD")
    except getopt.GetoptError:
        #print help
        usage()
        sys.exit(2)
    for o,a in opts:
        #print "option: "+o
        if o in ["-l"]:
            load=1
        if o in ["-s"]:
            search=1
        if o in ["-f"]:
            filename=a
            #print "Using File: %s" % (filename)
        if o in ["-h"]:
            help=1
        if o in ["-d"]:
            description=a
        if o in ["-m"]:
            moderator=a
        if o in ["-k"]:
            keywords=a
        if o in ["-t"]:
            hash=a
        if o in ["-D"]:
            delete=1

    if help:
        usage()

    if search:
        if filename == "":
            print "I need a filename for that"
            usage()
        filebase=os.path.basename(filename)    
        getallhashes(filebase)
        
    elif load==1:
        if filename=="" and hash=="":
            print "Load: Must specify a hash (with -t) or a filename to hash."
            usage()
        #both filename and hash are not null
        if moderator == "":
            print "I need to know who you are, use -m"
            usage()

        if hash=="":
            hash=getmd5sum(filename)

        #now we cut off so we only store the last part of the filename
        filename=os.path.basename(filename)
        insertentry(filename,hash,moderator,description,keywords)

    elif delete==1:
        if filename=="" and hash=="":
            print "Delete: Must specify a hash (with -t) or a filename (with -f) to hash."
            usage()
        #both filename and hash are not null

        if filename!="" and hash!="":
            print "Can't specify both a hash and a filename to delete"
            usage()

        if hash!="":
            deletehash(hash)
        if filename!="":
            deletefile(filename)
            
    else:
        print "Must specify load, search or delete"
        usage()
        




